package org.eclipse.core.internal.commands.operations;

import org.eclipse.core.commands.operations.IUndoContext;

/**
 * <p>
 * An operation context that matches to any context.  It can be used to 
 * get an unfiltered (global) history.
 * </p>
 * 
 * @backported from Eclipse 3.1
 */
public class GlobalUndoContext implements IUndoContext {

   /* (non-Javadoc)
    * @see org.eclipse.core.commands.operations.IUndoContext#getLabel()
    */
   public String getLabel() {
      return "Global Undo Context"; //$NON-NLS-1$
   }
   
   /* (non-Javadoc)
    * @see org.eclipse.core.commands.operations.IUndoContext#matches(IUndoContext context)
    */
   public boolean matches(IUndoContext context) {
      return true;
   }
}
