package com.qualityeclipse.favorites.actions;

import java.util.Iterator;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IActionDelegate;
import org.eclipse.ui.IEditorActionDelegate;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IViewActionDelegate;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IWorkbenchPart;

import com.qualityeclipse.favorites.model.FavoritesManager;

public class AddToFavoritesActionDelegate
   implements IObjectActionDelegate, IViewActionDelegate, IEditorActionDelegate 
{
   /**
    * The currently selected object in the active view
    */
   private ISelection selection;
   
   /**
    * Sets the active part for the delegate. This method will be called
    * every time the action appears in a context menu. The targetPart
    * may change with each invocation.
    */
   public void setActivePart(IAction action, IWorkbenchPart part) {
   }

   /**
    * Initializes this action delegate with the view it will work in.
    * 
    * @param view the view that provides the context for this delegate
    * @see IViewActionDelegate#init(IViewPart)
    */
   public void init(IViewPart view) {
   }

   /**
    * Sets the active editor for the delegate. Implementors should
    * disconnect from the old editor, connect to the new editor, and
    * update the action to reflect the new editor.
    * 
    * @param action the action proxy that handles presentation portion
    *           of the action
    * @param editor the new editor target
    * @see IEditorActionDelegate #setActiveEditor(IAction, IEditorPart)
    */
   public void setActiveEditor(IAction action, IEditorPart editor) {
   }
   
   /**
    * Notifies this action delegate that the selection in the
    * workbench has changed.
    * 
    * @param action the action proxy that handles presentation portion
    *           of the action
    * @param selection the current selection, or <code>null</code>
    *           if there is no selection.
    * @see IActionDelegate#selectionChanged(IAction, ISelection)
    */
   public void selectionChanged(IAction action, ISelection selection) {
      this.selection = selection;
      action.setEnabled(!selection.isEmpty());
   }

   /**
    * Called when the user has selected this action to be executed.
    */
   public void run(IAction action) {
      if (selection instanceof IStructuredSelection) {
         FavoritesManager mgr = FavoritesManager.getManager();
         Iterator iter = ((IStructuredSelection) selection).iterator();
         mgr.addFavorites(mgr.newFavoritesFor(iter));
      }
   }
}
