package com.qualityeclipse.favorites.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchPartSite;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.actions.ActionDelegate;

import com.qualityeclipse.favorites.wizards.ExtractStringsWizard;

/**
 * An action delegate that launches the Extract Strings wizard
 */
public class ExtractStringsActionDelegate extends ActionDelegate
      implements IObjectActionDelegate
{
   private IWorkbenchPart targetPart;
   private IStructuredSelection selection;

   public void setActivePart(IAction action, IWorkbenchPart targetPart)
   {
      this.targetPart = targetPart;
   }

   public void selectionChanged(IAction action, ISelection selection) {
      this.selection =
         selection instanceof IStructuredSelection
            ? (IStructuredSelection) selection
            : null;
   }

   public void run(IAction action) {
      IWorkbenchPartSite site = targetPart.getSite();
      IWorkbenchWindow window = site.getWorkbenchWindow();
      ExtractStringsWizard wizard = new ExtractStringsWizard();
      wizard.init(window.getWorkbench(), selection);
      WizardDialog dialog = new WizardDialog(window.getShell(), wizard);
      dialog.open();
   }
}
