package com.qualityeclipse.favorites.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;

import com.qualityeclipse.favorites.FavoritesLog;

public class OpenFavoritesViewAction extends Action {
   /**
    * The unique identifier for the favorites view
    */
   private static final String FAVORITES_VIEW_ID =
      "com.qualityeclipse.favorites.views.FavoritesView";

   /**
    * Open the favorites view.
    */
   public void run() {
      IWorkbenchPage page = PlatformUI
      	.getWorkbench()
      	.getActiveWorkbenchWindow()
      	.getActivePage();
      if (page == null)
         return;
      try {
         page.showView(FAVORITES_VIEW_ID);
      }
      catch (PartInitException e) {
         FavoritesLog.logError(
            "Failed to open the Favorites view",
            e);
      }
   }
}
