package com.qualityeclipse.favorites.actions;

import org.eclipse.core.resources.IResource;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.ui.JavaUI;
import org.eclipse.jface.action.Action;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.ui.part.ResourceTransfer;

import com.qualityeclipse.favorites.model.FavoritesManager;
import com.qualityeclipse.favorites.views.FavoritesView;

public class PasteFavoritesAction extends Action
{
   private FavoritesView view;

   public PasteFavoritesAction(FavoritesView view, String text) {
      super(text);
      this.view = view;
   }

   public void run() {
      if (pasteResources())
         return;
      if (pasteJavaElements())
         return;
      // Other transfer types here.
   }

   private boolean pasteResources() {
      ResourceTransfer transfer =
         ResourceTransfer.getInstance();
      IResource[] resources = (IResource[]) 
         view.getClipboard().getContents(transfer);
      if (resources == null || resources.length == 0)
         return false;
      FavoritesManager mgr = FavoritesManager.getManager();
      mgr.addFavorites(mgr.newFavoritesFor(resources));
      return true;
   }

   private boolean pasteJavaElements() {
      Transfer transfer =
         JavaUI.getJavaElementClipboardTransfer();
      IJavaElement[] elements = (IJavaElement[]) 
         view.getClipboard().getContents(transfer);
      if (elements == null || elements.length == 0)
         return false;
      FavoritesManager mgr = FavoritesManager.getManager();
      mgr.addFavorites(mgr.newFavoritesFor(elements));
      return true;
   }
}