package com.qualityeclipse.favorites.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

import com.qualityeclipse.favorites.FavoritesPlugin;
import com.qualityeclipse.favorites.dialogs.ExceptionDetailsDialog;

/**
 * Action delegate that opens the ExceptionDetailsDialog displaying a
 * fake exception
 */
public class TestExceptionDetailsDialog
      implements IWorkbenchWindowActionDelegate
{
   private IWorkbenchWindow window;

   public void init(IWorkbenchWindow window) {
      this.window = window;
   }

   public void selectionChanged(IAction action, ISelection selection) {
   }

   public void run(IAction action) {
      try {
         throw new RuntimeException("Fake Exception");
      }
      catch (Exception e) {
         new ExceptionDetailsDialog(
            window.getShell(),                      // parent shell 
            "Test",                                 // title
            null,                 // image (defaults to error image)
            "This is a fake exception to test the " // the message
               + ExceptionDetailsDialog.class.getName()
               + " dialog.", 
            e,             // the details - in this case an exception
            FavoritesPlugin.getDefault() // the plugin that triggered the exception
         ).open();
      }
   }

   public void dispose() {
   }
}
