package com.qualityeclipse.favorites.views;

import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.DragSource;
import org.eclipse.swt.dnd.DragSourceEvent;
import org.eclipse.swt.dnd.DragSourceListener;
import org.eclipse.swt.dnd.TextTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.ui.part.ResourceTransfer;

import com.qualityeclipse.favorites.actions.CopyFavoritesAction;

public class FavoritesDragSource
   implements DragSourceListener
{
   private FavoritesView view;
   
   public FavoritesDragSource(
      FavoritesView view,
      TableViewer viewer
   ) {
      this.view = view;
      DragSource source =
         new DragSource(viewer.getControl(), DND.DROP_COPY);
      source.setTransfer(
         new Transfer[] {
            TextTransfer.getInstance(),
            ResourceTransfer.getInstance()});
      source.addDragListener(this);
   }
   
   public void dragStart(DragSourceEvent event) {
      event.doit = view.getSelectedFavorites().length > 0;
   }
   
   public void dragSetData(DragSourceEvent event) {
      if (TextTransfer.getInstance()
         .isSupportedType(event.dataType)) {
         event.data =
            CopyFavoritesAction.asText(
               view.getSelectedFavorites());
      }
      else if (ResourceTransfer.getInstance()
         .isSupportedType(event.dataType)) {
         event.data =
            CopyFavoritesAction.asResources(
               view.getSelectedFavorites());
      }
   }
   public void dragFinished(DragSourceEvent event) {
      // If this was a MOVE operation, 
      // then remove the items that were moved.
   }
}